package Flo.androdroid;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.SeekBar;
import android.widget.SeekBar.OnSeekBarChangeListener;
import android.widget.TextView;
import android.widget.ToggleButton;

public class AndrodroidActivity extends Activity implements OnSeekBarChangeListener 
{
	ToggleButton conn_but;
	TextView bt_state;
	TBlue tblue;
	Button avance;
	Button recule;
	Button droite;
	Button gauche;
	Button arret;
	TextView angle_tete;
	SeekBar pos_bar;
	TextView dist;
	String dist_recu;
	
	int pos;
	
	private Handler handler = new Handler()
    {
    	public void handleMessage(android.os.Message msg)
    	{
    		if(msg.what == 0)
    		{
    			
    			/*
    			 * 270 -> 10
    			 * dist_recu -> x 
    			 * 
    			 */
    		dist.setText(dist_recu);
    		}
    	}
    };
	
    @Override
    public void onCreate(Bundle savedInstanceState) 
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        conn_but = (ToggleButton)findViewById(R.id.conn_bt);
        bt_state = (TextView)findViewById(R.id.bt_etat);
        avance = (Button)findViewById(R.id.av);
        recule = (Button)findViewById(R.id.re);
        gauche = (Button)findViewById(R.id.ga);
        droite = (Button)findViewById(R.id.dr);
        arret = (Button)findViewById(R.id.stop);
        pos_bar = (SeekBar)findViewById(R.id.pos_barre);
        angle_tete = (TextView)findViewById(R.id.angle);
        dist = (TextView)findViewById(R.id.dist);
        
        
        
        conn_but.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				if(conn_but.isChecked())
				{
					tblue = new TBlue("00:06:66:06:BF:3A");
					if(tblue.streaming())
					{
						bt_state.setText("connecter");
						
						Reception_donne();
						
						avance.setEnabled(true);
						recule.setEnabled(true);
						gauche.setEnabled(true);
						droite.setEnabled(true);
					}
					else
					{
						bt_state.setText("erreur!");
					}
				}
				else
				{
					tblue.close();
					if(tblue.streaming())
					{
						bt_state.setText("erreur deco!");
					}
					else
						bt_state.setText("deco");
						avance.setEnabled(false);
						recule.setEnabled(false);
						gauche.setEnabled(false);
						droite.setEnabled(false);
				}
				
			}
		});
        
        pos_bar.setOnSeekBarChangeListener(this);
        avance.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View arg0)
			{
				tblue.write("a");
			}
		});
        recule.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) 
			{
				tblue.write("r");
			}
		});
        gauche.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) 
			{
				tblue.write("g");
			}
		});
        droite.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) 
			{
				tblue.write("d");
				
			}
		});
        arret.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				tblue.write("w");
				
			}
		});
    }

	@Override
	public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) 
	{
		pos = pos_bar.getProgress();
		pos = (180*pos)/100;
		angle_tete.setText(""+pos);
		tblue.write(""+pos);
		tblue.write("s");
		
	}

	@Override
	public void onStartTrackingTouch(SeekBar seekBar) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void onStopTrackingTouch(SeekBar seekBar) {
		// TODO Auto-generated method stub
		
	}
	
	private void Reception_donne()
    {
    	new Thread(new Runnable() {
			
			@Override
			public void run() 
			{
				while(tblue.streaming())
				{
					try {
						Thread.sleep(1000);
						dist_recu = tblue.read();
					} 
					catch (InterruptedException e) 
					{
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					
					handler.sendEmptyMessage(0);
				}
				
				
			}
		}).start();
    }  
	
	public void onStop()
	{
		if(tblue.streaming())
		{
		tblue.close();
		}
	}
}